1 # Customize maint.mk -*- makefile -*-
2 # Copyright (C) 2003-2022 Free Software Foundation, Inc.
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 3 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see <https://www.gnu.org/licenses/>.
17 # Used in maint.mk's web-manual rule
18 manual_title
= Core GNU utilities
20 # Use the direct link. This is guaranteed to work immediately, while
21 # it can take a while for the faster mirror links to become usable.
22 url_dir_list
= https
://ftp.gnu.org
/gnu
/$(PACKAGE
)
24 # Exclude bundled external projects from syntax checks
25 VC_LIST_ALWAYS_EXCLUDE_REGEX
= src
/blake2
/.
*$$
27 # Tests not to run as part of "make distcheck".
28 local-checks-to-skip
= \
29 sc_proper_name_utf8_requires_ICONV \
32 # Tools used to bootstrap this package, used for "announcement".
33 bootstrap-tools
= autoconf
,automake
,gnulib
,bison
35 # Now that we have better tests, make this the default.
38 # Comparing tarball sizes compressed using different xz presets, we see that
39 # an -8e-compressed tarball is only 9KiB larger than the -9e-compressed one.
40 # Using -8e is preferred, since that lets the decompression process use half
41 # the memory (32MiB rather than 64MiB).
42 # $ for i in {7,8,9}{e,}; do \
43 # (n=$(xz -$i < coreutils-8.15*.tar|wc -c);echo $n $i) & done |sort -nr
52 old_NEWS_hash
= 612bad626bf28b1847ad0114cb2cd6fe
54 # Add an exemption for sc_makefile_at_at_check.
55 _makefile_at_at_check_exceptions
= ' && !/^cu_install_prog/ && !/dynamic-dep/'
57 # Our help-version script is in a slightly different location.
58 _hv_file ?
= $(srcdir)/tests
/misc
/help-version
60 # Ensure that the list of O_ symbols used to compute O_FULLBLOCK is complete.
61 dd
= $(srcdir)/src
/dd.c
64 @
{ echo O_FULLBLOCK
; echo O_NOCACHE
; \
65 perl
-nle
'/^ +\| (O_\w*)$$/ and print $$1' $(dd
); } |
sort > $@
.1
66 @
{ echo O_NOFOLLOW
; perl
-nle
'/{"[a-z]+",\s*(O_\w+)},/ and print $$1' \
67 $(dd
); } |
sort > $@
.2
68 @diff
-u
$@
.1 $@
.2; diff
=$$?
; \
71 ||
{ echo
'$(ME): $(dd) has inconsistent O_ flag lists'>&2; \
74 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
75 # with the strings from the two affected variables.
76 dd_c
= $(srcdir)/src
/dd.c
78 ifneq ($(wildcard $(dd_c
)),)
79 @len
=$$( (sed
-n
'/conversions\[\] =$$/,/^};/p' $(dd_c
);\
80 sed
-n
'/flags\[\] =$$/,/^};/p' $(dd_c
) ) \
81 |sed
-n
'/"/s/^[^"]*"\([^"]*\)".*/\1/p'| wc
-L
);\
82 max
=$$(sed
-n
'/^#define LONGEST_SYMBOL /s///p' $(dd_c
) \
83 |tr
-d
'"' | wc
-L
); \
84 if
test "$$len" = "$$max"; then
:; else \
85 echo
'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
90 # Many m4 macros names once began with 'jm_'.
91 # On 2004-04-13, they were all changed to start with gl_ instead.
92 # Make sure that none are inadvertently reintroduced.
94 @grep
-nE
'jm_[A-Z]' \
95 $$($(VC_LIST
) m4 |grep
'\.m4$$'; echo
/dev
/null
) && \
96 { echo
'$(ME): do not use jm_ in m4 macro names' \
99 # Ensure that each root-requiring test is run via the "check-root" rule.
101 @t1
=sc-root.expected
; t2
=sc-root.actual
; \
102 grep
-nl
'^ *require_root_$$' `$(VC_LIST) tests` | \
103 sed
's|.*/tests/|tests/|' |
sort > $$t1; \
104 for t in
$(all_root_tests
); do echo
$$t; done |
sort > $$t2; \
105 st
=0; diff
-u
$$t1 $$t2 || st
=1; \
109 # Ensure that all version-controlled test cases are listed in $(all_tests).
110 sc_tests_list_consistency
:
112 test_extensions_rx
=`echo $(TEST_EXTENSIONS) \
113 | sed -e "s/ /|/g" -e "s/$$bs./$$bs$$bs./g"`; \
115 for t in
$(all_tests
); do echo
$$t; done
; \
117 $(SHELL
) build-aux
/vc-list-files tests \
118 | grep
-Ev
'^tests/(factor/(run|create-test)|init)\.sh$$' \
119 |
$(EGREP
) "$$test_extensions_rx\$$"; \
120 } |
sort | uniq
-u | grep .
&& exit
1; :
122 # Ensure that all version-controlled test scripts are executable.
124 @set
-o noglob
2>/dev
/null || set
-f
; \
126 find_ext
="-name '' "`printf -- "-o -name *%s " $(TEST_EXTENSIONS)`;\
127 find
$(srcdir)/tests
/ \
( $$find_ext \
) \
! -perm
-u
+x
-print \
128 |
{ sed
"s|^$(srcdir)/||"; git ls-files
$(srcdir)/tests
/; } \
130 | sed
-e
"s/^/$(ME): Please make test executable: /" | grep . \
133 # Ensure all gnulib patches apply cleanly
134 sc_ensure_gl_diffs_apply_cleanly
:
135 @find
$(srcdir)/gl
/ -name
'*.diff' | while read p
; do \
136 patch
--fuzz
=0 -f
-s
-d
$(srcdir)/gnulib
/ -p1
--dry-run
< "$$p" >&2 \
137 ||
{ echo
"$$p" >&2; echo
'To refresh all gl patches run:' \
138 'make refresh-gnulib-patches' >&2; exit
1; } \
141 # Avoid :>file which doesn't propagate errors
142 sc_prohibit_colon_redirection
:
143 @cd
$(srcdir)/tests
&& GIT_PAGER
= git grep
-En
': *>.*\|\|' \
144 && { echo
'$(ME): '"The leading colon in :> will hide errors" >&2; \
148 # Ensure emit_mandatory_arg_note() is called if required
149 sc_ensure_emit_mandatory_arg_note
:
150 @cd
$(srcdir)/src
&& GIT_PAGER
= git \
151 grep
-l
-- '^ *-[^-].*--.*[^[]=' *.c \
152 | xargs grep
-L emit_mandatory_arg_note | grep . \
153 && { echo
'$(ME): '"emit_mandatory_arg_note() missing" 1>&2; \
156 # Create a list of regular expressions matching the names
157 # of files included from system.h. Exclude a couple.
159 @sed
-n
'/^# *include /s///p' $(srcdir)/src
/system.h \
160 | grep
-Ev
'sys/(param|file)\.h' \
161 | sed
's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
166 Exit
() { set
+e
; (exit
$$1); exit
$$1; }; \
167 for sig in
1 2 3 13 15; do \
168 eval
"trap 'Exit $$(expr $$sig + 128)' $$sig"; \
172 # Files in src/ should not include directly any of
173 # the headers already included via system.h.
174 sc_system_h_headers
: .re-list
175 @if
test -f
$(srcdir)/src
/system.h
; then \
176 trap
'rc=$$?; rm -f .re-list; exit $$rc' 0; \
178 grep
-nE
-f .re-list \
179 $$($(VC_LIST_EXCEPT
) | grep
-E
'^($(srcdir)/)?src/') \
180 && { echo
'$(ME): the above are already included via system.h'\
181 1>&2; exit
1; } ||
:; \
184 # Files in src/ should not use '%s' notation in format strings,
185 # i.e., single quotes around %s (or similar) should be avoided.
186 sc_prohibit_quotes_notation
:
187 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
"\".*[\`']%s'.*\"" *.c \
188 && { echo
'$(ME): '"Use quote() to avoid quoted '%s' notation" 1>&2; \
192 # Files in src/ should quote all strings in error() output, so that
193 # unexpected input chars like \r etc. don't corrupt the error.
194 # In edge cases this can be avoided by putting the format string
195 # on a separate line to the following arguments.
197 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
'error *(.*%s.*, [^(]*);$$'\
198 *.c | grep
-v
', q' \
199 && { echo
'$(ME): '"Use quote() for error string arguments" 1>&2; \
203 # Files in src/ should quote all file names in error() output
204 # using quotef(), to provide quoting only when necessary,
205 # but also provide better support for copy and paste when used.
206 sc_error_shell_quotes
:
207 @cd
$(srcdir)/src
&& \
208 { GIT_PAGER
= git grep
-E \
209 'error \(.*%s[:"], .*(name|file)[^"]*\);$$' *.c
; \
210 GIT_PAGER
= git grep
-E \
211 ' quote[ _].*file' *.c
; } \
212 | grep
-Ev
'(quotef|q[^ ]*name)' \
213 && { echo
'$(ME): '"Use quotef() for colon delimited names" 1>&2; \
217 # Files in src/ should quote all file names in error() output
218 # using quoteaf() when the name is separated with spaces,
219 # to distinguish the file name at issue and
220 # to provide better support for copy and paste.
221 sc_error_shell_always_quotes
:
222 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-E \
223 'error \(.*[^:] %s[ "].*, .*(name|file)[^"]*\);$$' \
224 *.c | grep
-Ev
'(quoteaf|q[^ ]*name)' \
225 && { echo
'$(ME): '"Use quoteaf() for space delimited names" 1>&2; \
228 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-E
-A1 \
229 'error \([^%]*[^:] %s[ "]' *.c | grep
'quotef' \
230 && { echo
'$(ME): '"Use quoteaf() for space delimited names" 1>&2; \
234 # Usage of error() with an exit constant, should instead use die(),
235 # as that avoids warnings and may generate better code, due to being apparent
236 # to the compiler that it doesn't return.
238 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-E \
239 'error \(.*_(FAILURE|INVALID)' \
240 && { echo
'$(ME): '"Use die() instead of error" 1>&2; \
244 # Avoid unstyled quoting to internal slots and thus destined for diagnostics
245 # as that can leak unescaped control characters to the output, when using
246 # the default "literal" quoting style.
247 # Instead use quotef(), or quoteaf() or in edge cases quotearg_n_style_colon().
248 # A more general PCRE would be @prohibit='quotearg_.*(?!(style|buffer))'
249 sc_prohibit-quotearg
:
250 @prohibit
='quotearg(_n)?(|_colon|_char|_mem) ' \
251 in_vc_files
='\.c$$' \
252 halt
='Unstyled diagnostic quoting detected' \
256 @prohibit
='\|\| skip ' \
257 halt
='Use skip_ not skip' \
262 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
263 $$($(VC_LIST_EXCEPT
)) && \
264 { echo
'$(ME): found misuse of Sun OS version numbers' 1>&2; \
267 # Ensure that the list of programs and author names is accurate.
268 # We need a UTF8 locale. If a lack of locale support or a missing
269 # translation inhibits printing of UTF-8 names, just skip this test.
270 au_dotdot
= authors-dotdot
271 au_actual
= authors-actual
272 sc_check-AUTHORS
: $(all_programs
)
273 @locale
=en_US.UTF-8
; \
274 LC_ALL
=$$locale .
/src
/factor
--version \
275 | grep
' Torbjorn ' > /dev
/null \
276 && { echo
"$@: skipping this check"; exit
0; }; \
277 rm -f
$(au_actual
) $(au_dotdot
); \
278 for i in
`ls $(all_programs) \
279 | sed -e 's,^src/,,' -e 's,$(EXEEXT)$$,,' \
281 | $(ASSORT) -u`; do \
282 test "$$i" = '[' && continue
; \
284 if
test "$$i" = install; then \
286 elif
test "$$i" = test; then \
289 LC_ALL
=$$locale .
/src
/$$exe --version \
290 | perl
-0 -p
-e
's/,\n/, /gm' \
291 | sed
-n
-e
'/Written by /{ s//'"$$i"': /;' \
292 -e
's/,* and /, /; s/\.$$//; p; }'; \
293 done
> $(au_actual
) && \
294 sed
-n
'/^[^ ][^ ]*:/p' $(srcdir)/AUTHORS
> $(au_dotdot
) \
295 && diff
$(au_actual
) $(au_dotdot
) \
296 && rm -f
$(au_actual
) $(au_dotdot
)
298 # Each program with a non-ASCII author name must link with LIBICONV.
299 sc_check-I18N-AUTHORS
:
300 @cd
$(srcdir)/src
&& \
301 for i in
$$(git grep
-l
-w proper_name_utf8
*.c|sed
's/\.c//'); do \
302 grep
-E
"^src_$${i}_LDADD"' .?= .*\$$\(LIBICONV\)' local.mk \
304 ||
{ echo
"$(ME): link rules for $$i do not include" \
305 '$$(LIBICONV)' 1>&2; exit
1; }; \
308 # Disallow the C99 printf size specifiers %z and %j as they're not portable.
309 # The gnulib printf replacement does support them, however the printf
310 # replacement is not currently explicitly depended on by the gnulib error()
311 # module for example. Also we use fprintf() in a few places to output simple
312 # formats but don't use the gnulib module as it is seen as overkill at present.
313 # We'd have to adjust the above gnulib items before disabling this.
314 sc_prohibit-c99-printf-format
:
315 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
'%[0*]*[jz][udx]' *.c \
316 && { echo
'$(ME): Use PRI*MAX instead of %j or %z' 1>&2; exit
1; } \
319 # Ensure the alternative __attribute (keyword) form isn't used as
320 # that form is not elided where required. Also ensure that we don't
321 # directly use attributes already defined by gnulib.
322 # TODO: move the check for _GL... attributes to gnulib.
323 sc_prohibit-gl-attributes
:
324 @prohibit
='__attribute |__(unused|pure|const)__' \
325 in_vc_files
='\.[ch]$$' \
326 halt
='Use _GL... attribute macros' \
329 # Prefer the const declaration form, with const following the type
330 sc_prohibit-const-char
:
331 @prohibit
='const char \*' \
332 in_vc_files
='\.[ch]$$' \
333 halt
='Use char const *, not const char *' \
336 # Look for lines longer than 80 characters, except omit:
338 # - the fdl.texi file copied from gnulib,
339 # - the help2man script copied from upstream,
340 # - tests involving long checksum lines, and
341 # - the 'pr' test cases.
342 FILTER_LONG_LINES
= \
343 \|^
[^
:]*NEWS
:.
*https\
{,1\
}://| d
; \
344 \|^
[^
:]*doc
/fdl.texi
:| d
; \
345 \|^
[^
:]*man
/help2man
:| d
; \
346 \|^
[^
:]*tests
/misc
/sha
[0-9]*sum.
*\.pl
[-:]| d
; \
347 \|^
[^
:]*tests
/pr
/|
{ \|^
[^
:]*tests
/pr
/pr-tests
:|
!d
; };
349 @wc
-L
/dev
/null
>/dev
/null
2>/dev
/null \
350 ||
{ echo
"$@: skipping: wc -L not supported"; exit
0; }; \
351 sed
-r
1q
/dev
/null
2>/dev
/null \
352 ||
{ echo
"$@: skipping: sed -r not supported"; exit
0; }; \
353 files
=$$($(VC_LIST_EXCEPT
) | xargs wc
-L | sed
-rn
'/ total$$/d;\
354 s/^ *(8[1-9]|9[0-9]|[0-9]{3,}) //p'); \
355 halt
='line(s) with more than 80 characters; reindent'; \
356 for file in
$$files; do \
357 expand
$$file | grep
-nE
'^.{80}.' | \
358 sed
-e
"s|^|$$file:|" -e
'$(FILTER_LONG_LINES)'; \
359 done | grep .
&& { msg
="$$halt" $(_sc_say_and_exit
) } ||
:
361 # Option descriptions should not start with a capital letter.
362 # One could grep source directly as follows:
363 # grep -E " {2,6}-.*[^.] [A-Z][a-z]" $$($(VC_LIST_EXCEPT) | grep '\.c$$')
364 # but that would miss descriptions not on the same line as the -option.
365 sc_option_desc_uppercase
: $(ALL_MANS
)
366 @grep
'^\\fB\\-' -A1 man
/*.1 | LC_ALL
=C grep
'\.1.[A-Z][a-z]' \
367 && { echo
1>&2 '$@: found initial capitals in --help'; exit
1; } ||
:
369 # Ensure all man/*.[1x] files are present.
370 sc_man_file_correlation
: check-x-vs-1 check-programs-vs-x
372 # Ensure that for each .x file in the 'man/' subdirectory, there is a
373 # corresponding .1 file in the definition of $(EXTRA_MANS).
374 # But since that expansion usually lacks programs like arch and hostname,
375 # add them here manually.
378 @PATH
=.
/src
$(PATH_SEPARATOR
)$$PATH; export PATH
; \
380 (cd
$(srcdir)/man
&& ls
-1 *.x
) \
381 | sed
's/\.x$$//' |
$(ASSORT
) > $$t; \
382 (echo
$(patsubst man
/%,%,$(ALL_MANS
)) \
383 | tr
-s
' ' '\n' | sed
's/\.1$$//') \
384 |
$(ASSORT
) -u | diff
- $$t ||
{ rm $$t; exit
1; }; \
387 # Ensure that non-trivial .x files in the 'man/' subdirectory,
388 # i.e., files exceeding a line count of 20 or a byte count of 1000,
389 # contain a Copyright notice.
390 .PHONY
: sc_man_check_x_copyright
391 sc_man_check_x_copyright
:
393 cd
$(srcdir) && wc
-cl man
/*.x | head
-n-1 \
394 | awk
'$$1 >= 20 || $$2 >= 1000 {print $$3}' \
395 | xargs grep
-L
'Copyright .* Free Software Foundation' \
397 && { echo
1>&2 '$@: exceeding file size/line count limit' \
398 '- please add a copyright note'; status
=1; }; \
401 # Writing a portable rule to generate a manpage like '[.1' would be
402 # a nightmare, so filter that out.
403 all-progs-but-lbracket
= $(filter-out [,$(patsubst src
/%,%,$(all_programs
)))
405 # Ensure that for each coreutils program there is a corresponding
406 # '.x' file in the 'man/' subdirectory.
407 .PHONY
: check-programs-vs-x
410 for p in dummy
$(all-progs-but-lbracket
); do \
411 case
$$p in
*.so
) continue
;; esac
; \
412 test $$p = dummy
&& continue
; \
413 test $$p = ginstall
&& p
=install ||
: ; \
414 test -f
$(srcdir)/man
/$$p.x \
415 ||
{ echo missing
$$p.x
1>&2; status
=1; }; \
419 # Ensure we can check out on case insensitive file systems
420 sc_case_insensitive_file_names
: src
/uniq
421 @git
-C
$(srcdir) ls-files |
sort -f | src
/uniq
-Di | grep .
&& \
422 { echo
"$(ME): the above file(s) conflict on case insensitive" \
423 " file systems" 1>&2; exit
1; } ||
:
425 # Ensure that the end of each release's section is marked by two empty lines.
426 sc_NEWS_two_empty_lines
:
427 @sed
-n
4,/Noteworthy
/p
$(srcdir)/NEWS \
428 | perl
-n0e
'/(^|\n)\n\n\* Noteworthy/ or exit 1' \
429 ||
{ echo
'$(ME): use two empty lines to separate NEWS sections' \
432 # With split lines, don't leave an operator at end of line.
433 # Instead, put it on the following line, where it is more apparent.
434 # Don't bother checking for "*" at end of line, since it provokes
435 # far too many false positives, matching constructs like "TYPE *".
436 # Similarly, omit "=" (initializers).
437 binop_re_ ?
= [-/+^
!<>]|
[-/+*^
!<>=]=|
&&?|\|\|?|
<<=?|
>>=?
438 sc_prohibit_operator_at_end_of_line
:
439 @prohibit
='. ($(binop_re_))$$' \
440 in_vc_files
='\.[chly]$$' \
441 halt
='found operator at end of line' \
444 # Don't use address of "stat" or "lstat" functions
445 sc_prohibit_stat_macro_address
:
446 @prohibit
='\<l?stat '':|&l?stat\>' \
447 halt
='stat() and lstat() may be function-like macros' \
450 # Ensure that date's --help output stays in sync with the info
451 # documentation for GNU strftime. The only exception is %N and %q,
452 # which date accepts but GNU strftime does not.
454 # "info foo" fails with error, but not "info foo >/dev/null".
455 extract_char
= sed
's/^[^%][^%]*%\(.\).*/\1/'
457 @if
test -f
$(srcdir)/src
/date.c
; then \
458 if
info libc date calendar format
2>/dev
/null | \
459 grep
"^ *['\`]%.'$$" >$@
-tmp
; then \
460 { echo N
; echo q
; $(extract_char
) $@
-tmp
; }|
sort \
462 grep
'^ %. ' $(srcdir)/src
/date.c |
sort \
463 |
$(extract_char
) > $@
-src
; \
464 diff
-u
$@
-src
$@
-info || exit
1; \
466 echo
'$(ME): skipping $@: libc info not installed' 1>&2; \
468 rm -f
$@
-info $@
-src
$@
-tmp
; \
471 # Indent only with spaces.
472 sc_prohibit_tab_based_indentation
:
474 halt
='TAB in indentation; use only spaces' \
477 # Enforce lowercase 'e' in "I.e.".
478 sc_prohibit_uppercase_id_est
:
480 halt
='Uppercase "Id Est" abbreviation; use "I.e.," instead' \
483 # Enforce double-space before "I.e." at the beginning of a sentence.
484 sc_ensure_dblspace_after_dot_before_id_est
:
485 @prohibit
='\. I\.e\.' \
486 halt
='Single space after dot before "i.e."; use ". i.e." instead' \
489 # Enforce comma after "i.e." (at least before a blank or at EOL).
490 sc_ensure_comma_after_id_est
:
491 @prohibit
='[Ii]\.e\.( |$$)' \
492 halt
='Missing comma after "i.e."; use "i.e.," instead' \
495 # The SEE ALSO section of a man page should not be terminated with
496 # a period. Check the first line after each "SEE ALSO" line in man/*.x:
497 sc_prohibit_man_see_also_period
:
498 @grep
-nB1
'\.$$' $$($(VC_LIST_EXCEPT
) | grep
'man/.*\.x$$') \
499 | grep
-A1
-e
'-\[SEE ALSO\]' | grep
'\.$$' && \
500 { echo
'$(ME): do not end "SEE ALSO" section with a period' \
503 # Don't use "indent-tabs-mode: nil" anymore. No longer needed.
504 sc_prohibit_emacs__indent_tabs_mode__setting
:
505 @prohibit
='^( *[*#] *)?indent-tabs-mode:' \
506 halt
='use of emacs indent-tabs-mode: setting' \
509 # Ensure that tests don't include a redundant fail=0.
511 @prohibit
='\<fail=0\>' \
512 halt
='fail=0 initialization' \
515 # Ensure that tests don't use `cmd ... && fail=1` as that hides crashes.
516 # The "exclude" expression allows common idioms like `test ... && fail=1`
517 # and the 2>... portion allows commands that redirect stderr and so probably
518 # independently check its contents and thus detect any crash messages.
519 sc_prohibit_and_fail_1
:
520 @prohibit
='&& fail=1' \
521 exclude
='(returns_|stat|kill|test |EGREP|grep|compare|2> *[^/])' \
522 halt
='&& fail=1 detected. Please use: returns_ 1 ... || fail=1' \
523 in_vc_files
='^tests/' \
526 # Ensure that tests don't use `cmd ... || fail` as that's a noop.
528 @prohibit
='\|\| fail$$' \
530 halt
='|| fail detected. Please use: || fail=1' \
531 in_vc_files
='^tests/' \
534 # Ensure that env vars are not passed through returns_ as
535 # that was seen to fail on FreeBSD /bin/sh at least
536 sc_prohibit_env_returns
:
537 @prohibit
='=[^ ]* returns_ ' \
538 exclude
='_ returns_ ' \
539 halt
='Passing env vars to returns_ is non portable' \
540 in_vc_files
='^tests/' \
543 # The mode part of a setfacl -m option argument must be three bytes long.
544 # I.e., an argument of user:bin:rw or user:bin:r will make Solaris 10's
545 # setfacl reject it with: "Unrecognized character found in mode field".
546 # Use hyphens to give it a length of 3: "...:rw-" or "...:r--".
547 sc_prohibit_short_facl_mode_spec
:
548 @prohibit
='\<setfacl .*-m.*:.*:[rwx-]{1,2} ' \
549 halt
='setfacl mode string length < 3; extend with hyphen(s)' \
552 # Ensure that "stdio--.h" is used where appropriate.
553 sc_require_stdio_safer
:
554 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
555 files
=$$(grep
-l
'\bfreopen \?(' $$($(VC_LIST_EXCEPT
) \
556 | grep
'\.[ch]$$')); \
557 test -n
"$$files" && grep
-LE
'include "stdio--.h"' $$files \
559 { echo
'$(ME): the above files should use "stdio--.h"' \
560 1>&2; exit
1; } ||
:; \
564 sc_prohibit_perl_hash_quotes
:
565 @prohibit
="\{'[A-Z_]+' *[=}]" \
566 halt
="in Perl code, write \$$hash{KEY}, not \$$hash{'K''EY'}" \
569 # Prefer xnanosleep over other less-precise sleep methods
571 @prohibit
='\<(nano|u)?sleep \(' \
572 halt
='prefer xnanosleep over other sleep interfaces' \
575 # Use print_ver_ (from init.cfg), not open-coded $VERBOSE check.
576 sc_prohibit_verbose_version
:
577 @prohibit
='test "\$$VERBOSE" = yes && .* --version' \
578 halt
='use the print_ver_ function instead...' \
581 # Enforce print_ver_ tracking of dependencies
582 # Each coreutils specific program a test requires
583 # should be tagged by calling through env(1).
584 sc_env_test_dependencies
:
585 @cd
$(top_srcdir
) && GIT_PAGER
= git grep
-E \
586 "env ($$(build-aux/gen-lists-of-programs.sh --list-progs | \
587 grep -vF '[' |paste -d'|' -s))" tests | \
588 sed
"s/\([^:]\):.*env \([^)' ]*\).*/\1 \2/" | uniq | \
589 while read
test prog
; do \
590 printf
'%s' $$test | grep
-q
'\.pl$$' && continue
; \
591 grep
-q
"print_ver_.* $$prog" $$test \
592 || echo
$$test should call
: print_ver_
$$prog; \
593 done | grep .
&& exit
1 ||
:
595 # Use framework_failure_, not the old name without the trailing underscore.
596 sc_prohibit_framework_failure
:
597 @prohibit
='\<framework_''failure\>' \
598 halt
='use framework_failure_ instead' \
601 # Prohibit the use of `...` in tests/. Use $(...) instead.
602 sc_prohibit_test_backticks
:
603 @prohibit
='`' in_vc_files
='^tests/' \
604 halt
='use $$(...), not `...` in tests/' \
607 # Ensure that compare is used to check empty files
608 # so that the unexpected contents are displayed
609 sc_prohibit_test_empty
:
610 @prohibit
='test -s.*&&' in_vc_files
='^tests/' \
611 halt
='use `compare /dev/null ...`, not `test -s ...` in tests/' \
614 # Programs like sort, ls, expr use PROG_FAILURE in place of EXIT_FAILURE.
615 # Others, use the EXIT_CANCELED, EXIT_ENOENT, etc. macros defined in system.h.
616 # In those programs, ensure that EXIT_FAILURE is not used by mistake.
617 sc_some_programs_must_avoid_exit_failure
:
619 && grep
-nw EXIT_FAILURE \
620 $$(git grep
-El
'[^T]_FAILURE|EXIT_CANCELED' $(srcdir)/src
) \
621 | grep
-vE
'= EXIT_FAILURE|return .* \?' | grep . \
622 && { echo
'$(ME): do not use EXIT_FAILURE in the above' \
625 # Ensure that tests call the get_min_ulimit_v_ function if using ulimit -v
626 sc_prohibit_test_ulimit_without_require_
:
627 @
(git
-C
$(srcdir) grep
-l get_min_ulimit_v_ tests
; \
628 git
-C
$(srcdir) grep
-l
'ulimit -v' tests
) \
629 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
630 " should match get_min_ulimit_v_ with ulimit -v" 1>&2; exit
1; } ||
:
632 # Ensure that tests call the cleanup_ function if using background processes
633 sc_prohibit_test_background_without_cleanup_
:
634 @
(git
-C
$(srcdir) grep
-El
'( &$$|&[^&]*=\$$!)' tests
; \
635 git
-C
$(srcdir) grep
-l
'cleanup_()' tests | sed p
) \
636 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
637 " should use cleanup_ for background processes" 1>&2; exit
1; } ||
:
639 # Ensure that tests call the print_ver_ function for programs which are
640 # actually used in that test.
641 sc_prohibit_test_calls_print_ver_with_irrelevant_argument
:
642 @git
-C
$(srcdir) grep
-w print_ver_ tests \
643 | sed
's#:print_ver_##' \
645 while read file name
; do \
646 for i in
$$name; do \
647 case
"$$i" in
install) i
=ginstall
;; esac
; \
648 grep
-w
"$$i" $$file|grep
-vw print_ver_|grep
-q . \
650 echo
"*** Test: $$file, offending: $$i." 1>&2; };\
653 test $$fail = 0 || exit
1; \
654 } ||
{ echo
"$(ME): the above test(s) call print_ver_ for" \
655 "program(s) they don't use" 1>&2; exit
1; }
657 # Exempt the contents of any usage function from the following.
658 _continued_string_col_1
= \
659 s
/^usage .
*?
\n}//ms
;/\\\n\w
/ and
print ("$$ARGV\n"),$$e=1;END
{$$e||
=0;exit
$$e}
660 # Ding any source file that has a continued string with an alphabetic in the
661 # first column of the following line. We prohibit them because they usually
662 # trigger false positives in tools that try to map an arbitrary line number
663 # to the enclosing function name. Of course, very many strings do precisely
664 # this, *when they are part of the usage function*. That is why we exempt
665 # the contents of any function named "usage".
666 sc_prohibit_continued_string_alpha_in_column_1
:
667 @perl
-0777 -ne
'$(_continued_string_col_1)' \
668 $$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$') \
669 ||
{ echo
'$(ME): continued string with word in first column' \
671 # Use this to list offending lines:
672 # git ls-files |grep '\.[ch]$' | xargs \
673 # perl -n -0777 -e 's/^usage.*?\n}//ms;/\\\n\w/ and print "$ARGV\n"' \
674 # | xargs grep -A1 '\\$'|grep '\.[ch][:-][_a-zA-Z]'
677 ###########################################################
678 _p0
= \
([^
"'/]\|"\
([^
\"]\|
[\
].\
)*"\|'\([^\']\|[\].\)*'
679 _pre = $(_p0)\|[/][^"'/*]\|[/]"\([^\"]\|[\].\)*"\|[/]'\
([^
\']\|
[\
].\
)*'\)*
680 _pre_anchored = ^\($(_pre)\)
681 _comment_and_close = [^*]\|[*][^/*]\)*[*][*]*/
682 # help font-lock mode: '
684 # A sed expression that removes ANSI C and ISO C99 comments.
685 # Derived from the one in GNU gettext's 'moopp' preprocessor.
686 _sed_remove_comments
= \
690 s
,$(_pre_anchored
)//.
*,\
1,; \
692 s
,$(_pre_anchored
)/[*]\
($(_comment_and_close
),\
1 ,; \
695 s
,$(_pre_anchored
)/[*].
*,\
1 ,; \
699 s
,^\
($(_comment_and_close
),,; \
707 # Quote all single quotes.
708 _sed_rm_comments_q
= $(subst ','\'',$(_sed_remove_comments))
709 # help font-lock mode: '
711 _space_before_paren_exempt
=?
\\n
\\$$
712 _space_before_paren_exempt
= \
713 (^
*\
#|\\n\\$$|%s\(to %s|(date|group|character)\(s\))
714 # Ensure that there is a space before each open parenthesis in C code.
715 sc_space_before_open_paren
:
716 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
718 for c in
$$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$'); do \
719 sed
'$(_sed_rm_comments_q)' $$c 2>/dev
/null \
720 | grep
-i
'[[:alnum:]](' \
721 | grep
-vE
'$(_space_before_paren_exempt)' \
722 | grep .
&& { fail
=1; echo
"*** $$c"; }; \
725 { echo
'$(ME): the above files lack a space-before-open-paren' \
726 1>&2; exit
1; } ||
:; \
730 # Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
731 # Use STREQ_LEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
733 @prohibit
='^[^#].*str''ncmp *\(' \
734 halt
='use STREQ_LEN or STRPREFIX instead of str''ncmp' \
737 # Enforce recommended preprocessor indentation style.
738 sc_preprocessor_indentation
:
739 @if cppi
--version
>/dev
/null
2>&1; then \
740 $(VC_LIST_EXCEPT
) | grep
'\.[ch]$$' | xargs cppi
-a
-c \
741 ||
{ echo
'$(ME): incorrect preprocessor indentation' 1>&2; \
744 echo
'$(ME): skipping test $@: cppi not installed' 1>&2; \
747 # THANKS.in is a list of name/email pairs for people who are mentioned in
748 # commit logs (and generated ChangeLog), but who are not also listed as an
749 # author of a commit. Name/email pairs of commit authors are automatically
750 # extracted from the repository. As a very minor factorization, when
751 # someone who was initially listed only in THANKS.in later authors a commit,
752 # this rule detects that their pair may now be removed from THANKS.in.
753 sc_THANKS_in_duplicates
:
754 @
{ git
-C
$(srcdir) log
--pretty
=format
:%aN |
sort -u
; \
755 cut
-b-36
$(srcdir)/THANKS.in \
756 | sed
'/^$$/,/^$$/!d;/^$$/d;s/ *$$//'; } \
757 |
sort | uniq
-d | grep . \
758 && { echo
'$(ME): remove the above names from THANKS.in' \
761 # Ensure the contributor list stays sorted. However, if the system's
762 # en_US.UTF-8 locale data is erroneous, give a diagnostic and skip
763 # this test. This affects OS X, up to at least 10.11.6.
764 # Use our sort as other implementations may result in a different order.
766 @printf
'a\n.b\n'|LC_ALL
=en_US.UTF-8 src
/sort -c
2> /dev
/null \
768 sed
'/^$$/,/^$$/!d;/^$$/d' $(srcdir)/THANKS.in
> $@
.1 && \
769 LC_ALL
=en_US.UTF-8 src
/sort -f
-k1
,1 $@
.1 > $@
.2 && \
770 diff
-u
$@
.1 $@
.2; diff
=$$?
; \
773 ||
{ echo
'$(ME): THANKS.in is unsorted' 1>&2; exit
1; }; \
775 ||
{ echo
'$(ME): this system has erroneous locale data;' \
776 'skipping $@' 1>&2; }
778 # Look for developer diagnostics that are marked for translation.
779 # This won't find any for which devmsg's format string is on a separate line.
780 sc_marked_devdiagnostics
:
781 @prohibit
='\<devmsg *\(.*_\(' \
782 halt
='found marked developer diagnostic(s)' \
785 # Ensure we keep hex constants as 4 or 8 bytes for consistency
786 # and so that make src/fs-magic-compare works consistently
788 @sed
-n
's|.*/\* \(0x[0-9A-Fa-f]\{1,\}\) .*\*/|\1|p' \
789 $(srcdir)/src
/stat.c | grep
-Ev
'^0x([0-9A-F]{4}){1,2}$$' \
790 && { echo
'$(ME): Constants in src/stat.c should be 4 or 8' \
791 'upper-case chars' 1>&2; exit
1; } ||
:
793 # Ensure gnulib generated files are ignored
794 # TODO: Perhaps augment gnulib-tool to do this in lib/.gitignore?
795 sc_gitignore_missing
:
796 @
{ sed
-n
'/^\/lib\/.*\.h$$/{p;p}' $(srcdir)/.gitignore
; \
797 find lib
-name
'*.in*' ! -name
'*~' ! -name
'sys_*' | \
798 sed
's|^|/|; s|_\(.*in\.h\)|/\1|; s/\.in//'; } | \
799 sort | uniq
-u | grep .
&& { echo
'$(ME): Add above' \
800 'entries to .gitignore' >&2; exit
1; } ||
:
802 # Flag redundant entries in .gitignore
803 # Disabled for now as too aggressive flagging
804 # entries like /lib/arg-nonnull.h
805 #sc_gitignore_redundant:
806 # @{ grep ^/lib $(srcdir)/.gitignore; \
807 # sed 's|^|/lib|' $(srcdir)/lib/.gitignore; } | \
808 # sort | uniq -d | grep . && { echo '$(ME): Remove above' \
809 # 'entries from .gitignore' >&2; exit 1; } || :
811 sc_prohibit-form-feed
:
813 in_vc_files
='\.[chly]$$' \
814 halt
='Form Feed (^L) detected' \
817 # Override the default Cc: used in generating an announcement.
818 announcement_Cc_
= $(translation_project_
), \
819 coreutils@gnu.org
, coreutils-announce@gnu.org
821 -include $(srcdir)/dist-check.mk
823 update-copyright-env
= \
824 UPDATE_COPYRIGHT_FORCE
=1 \
825 UPDATE_COPYRIGHT_USE_INTERVALS
=2 \
826 UPDATE_COPYRIGHT_MAX_LINE_LENGTH
=79
828 # List syntax-check exemptions.
829 exclude_file_name_regexp--sc_space_tab
= \
830 ^
(tests
/pr
/|tests
/misc
/nl\.sh
$$|gl
/.
*\.diff
$$|man
/help2man
$$)
831 exclude_file_name_regexp--sc_bindtextdomain
= \
832 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list|src
/cksum
)\.c
$$
833 exclude_file_name_regexp--sc_trailing_blank
= \
834 ^
(tests
/pr
/|gl
/.
*\.diff
$$|man
/help2man
)
835 exclude_file_name_regexp--sc_system_h_headers
= \
836 ^src
/((die|system|copy|chown-core|find-mount-point
)\.h|make-prime-list\.c
)$$
838 _src
= (crctab|false|lbracket|ls-
(dir|ls|vdir
)|tac-pipe|uname-
(arch|uname
))
839 _gl_src
= (xdecto.max|cl-strtold
)
840 exclude_file_name_regexp--sc_require_config_h_first
= \
841 (^lib
/buffer-lcm\.c|gl
/lib
/$(_gl_src
)\.c|src
/$(_src
)\.c
)$$
842 exclude_file_name_regexp--sc_require_config_h
= \
843 $(exclude_file_name_regexp--sc_require_config_h_first
)
845 exclude_file_name_regexp--sc_po_check
= ^
(gl
/|man
/help2man
)
846 exclude_file_name_regexp--sc_prohibit_always-defined_macros
= \
847 ^src
/(seq|remove
)\.c
$$
848 exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF
= ^tests
/pr
/
849 exclude_file_name_regexp--sc_program_name
= \
850 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list
)\.c
$$
851 exclude_file_name_regexp--sc_file_system
= \
852 NEWS|^
(init\.cfg|src
/df\.c|tests
/df
/df-P\.sh|tests
/df
/df-output\.sh
)$$
853 exclude_file_name_regexp--sc_prohibit_always_true_header_tests
= \
855 exclude_file_name_regexp--sc_prohibit_fail_0
= \
856 (^.
*/git-hooks
/commit-msg|^tests
/init\.sh|Makefile\.am|\.mk|.
*\.texi
)$$
857 exclude_file_name_regexp--sc_prohibit_test_minus_ao
= *\.texi
$$
858 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^lib
/euidaccess-stat\.c
$$
860 # longlong.h is maintained elsewhere.
861 _ll
= ^src
/longlong\.h
$$
862 exclude_file_name_regexp--sc_useless_cpp_parens
= $(_ll
)
863 exclude_file_name_regexp--sc_space_before_open_paren
= $(_ll
)
865 tbi_1
= ^tests
/pr
/|
(\.mk|^man
/help2man
)$$
866 tbi_2
= ^scripts
/git-hooks
/(pre-commit|pre-applypatch|applypatch-msg
)$$
867 tbi_3
= (GNU
)?
[Mm
]akefile
(\.am
)?
$$|
$(_ll
)
868 exclude_file_name_regexp--sc_prohibit_tab_based_indentation
= \
869 $(tbi_1
)|
$(tbi_2
)|
$(tbi_3
)
871 exclude_file_name_regexp--sc_preprocessor_indentation
= \
872 ^
(gl
/lib
/rand-isaac\.
[ch
]|gl
/tests
/test-rand-isaac\.c
)$$|
$(_ll
)
873 exclude_file_name_regexp--sc_prohibit_stat_st_blocks
= \
874 ^
(src
/system\.h|tests
/du
/2g\.sh
)$$
876 exclude_file_name_regexp--sc_prohibit_continued_string_alpha_in_column_1
= \
877 ^src
/(system\.h|od\.c|printf\.c|getlimits\.c
)$$
879 exclude_file_name_regexp--sc_prohibit_test_backticks
= \
880 ^tests
/(local\.mk|
(init|misc
/stdbuf|factor
/create-test
)\.sh
)$$
882 # Exempt test.c, since it's nominally shared, and relatively static.
883 exclude_file_name_regexp--sc_prohibit_operator_at_end_of_line
= \
884 ^src
/(ptx|
test|head
)\.c
$$
886 exclude_file_name_regexp--sc_error_message_uppercase
= ^src
/factor\.c
$$
887 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^src
/make-prime-list\.c
$$
889 # Exception here as we don't want __attribute elided on non GCC
890 exclude_file_name_regexp--sc_prohibit-gl-attributes
= ^src
/libstdbuf\.c
$$
892 exclude_file_name_regexp--sc_prohibit_uppercase_id_est
= \.diff
$$
893 exclude_file_name_regexp--sc_ensure_dblspace_after_dot_before_id_est
= \.diff
$$
894 exclude_file_name_regexp--sc_ensure_comma_after_id_est
= \.diff|
$(_ll
)$$
895 exclude_file_name_regexp--sc_long_lines
= \.diff
$$|
$(_ll
)
897 # Augment AM_CFLAGS to include our per-directory options:
898 AM_CFLAGS
+= $($(@D
)_CFLAGS
)
900 src_CFLAGS
= $(WARN_CFLAGS
)
901 lib_CFLAGS
= $(GNULIB_WARN_CFLAGS
)
902 gnulib-tests_CFLAGS
= $(GNULIB_TEST_WARN_CFLAGS
)
904 # Configuration to make the tight-scope syntax-check rule work with
905 # non-recursive make.
906 # Note _gl_TS_headers use _single line_ extern function declarations,
907 # while *_SOURCES use the _two line_ form.
908 export _gl_TS_headers
= $(noinst_HEADERS
)
909 # Add exceptions for --enable-single-binary renamed functions.
910 _gl_TS_unmarked_extern_functions
= main usage
911 _gl_TS_unmarked_extern_functions
+= single_binary_main_.
* _usage_.
*
912 # Headers to search for single line extern _data_ declarations.
913 _gl_TS_other_headers
= $(srcdir)/src
/*.h src
/*.h
914 # Tell the tight_scope rule about an exceptional "extern" variable.
915 # Normally, the rule would detect its declaration, but that uses a
916 # different name, __clz_tab.
917 _gl_TS_unmarked_extern_vars
= factor_clz_tab
918 # Other tight_scope settings
920 _gl_TS_obj_files
= src
/*.
$(OBJEXT
)